# Project Description
Lingua.NET is a .NET-based parser generator.  It uses reflection to generate parsers and scanners using code-based scanner and grammar definitions.

This project contains:
* Lingua - the base Lingua.NET library.
* LinguaDemo - a small WPF application that evaluates simple mathematical expressions.

## Notes
* Please see [Documentation](Documentation) page for additional information about Lingua.NET.
* The project source code currently contains TFS source control bindings.  These bindings should be removed if you have not installed the Visual Studio Team Explorer.

## Project Status
This project is under active development.  Current areas of development include:
* Improved conflict resolution.
* Support for LALR(1) parsers.  Lingua.NET currently generates SLR parsers.
* Optional rule arguments.

## Additional References
For additional information about parsers, the following resources are recommended:
* [Compilers: Principles, Techniques, & Tools](http://www.amazon.com/Compilers-Principles-Techniques-Tools-Gradiance/dp/0321547985/ref=sr_1_2?ie=UTF8&s=books&qid=1256271897&sr=8-2)
* [Simple LR parser](http://en.wikipedia.org/wiki/Simple_LR_parser)
